// copyright Evert Mouw <post@evert.net>

#include <iostream>
#include "schelling.h"
using namespace std;

int main(){
	const int numberofturns = 10;

	cout << "Schelling sim by Evert Mouw <post@evert.net>, 2013-10-02" << endl;
	cout << "https://en.wikipedia.org/wiki/Thomas_Schelling#Models_of_segregation" << endl;
	cout << "During each turn, each 'home' has a 10% chance to move, but only " << endl;
	cout << "does so when it has less than 2 kindred neighbours." << endl;
	cout << "Each family wants to move to a home with kindred neighbours." << endl;

	schelling * S = new schelling();
	S->clear();
	S->fillrandom();

	cout << endl;
	cout << "initial random board:" << endl;
	cout << endl;
	S->print();

	for (int i=0; i<numberofturns; i++) S->turn();

	cout << endl;
	cout << "after " << numberofturns << " turns:" << endl;
	cout << endl;
	S->print();

	delete S;

	return 0;
}
