// copyright Evert Mouw <post@evert.net>

// max 9 kinds of groups,
// otherwise schelling::print() will break
#define KINDS 3

#if defined (__WIN32__) || defined(WIN32) || defined(_WIN32)
	// Windows has no ASCII support for cmd.exe
	// (Cygwin will handle colors in good order.)
	#define ASCIICOLOR false
#else
	#define ASCIICOLOR true
#endif

#include <iostream>
#include <cstdlib>
#include "schelling.h"
using namespace std;

schelling::schelling(){
	clear();
	fillrandom();
}

void schelling::print(){
	// prints board to terminal
	color = ASCIICOLOR;
	int i,j;
	for (i=0; i<XXX; i++) {
		for (j=0; j<YYY; j++) {
			if (color) cout << "\033[0;" << 30+board[i][j] << "m";
			cout << board[i][j];
		}
		cout << endl;
	}
	if (color) cout << "\033[0m";
}

void schelling::clear(){
	// fill board with zeroes
	int i,j;
	for (i=0; i<XXX; i++) {
		for (j=0; j<YYY; j++) {
			board[i][j] == 0;
		}
	}
}

void schelling::fillrandom(){
	// fills board with random numbers
	int r;
	int i,j;
	for (i=0; i<XXX; i++) {
		for (j=0; j<YYY; j++) {
			r = rand() % (KINDS+1); // leave a few zero's as empty spaces
			board[i][j] = r;
		}
	}
}

void schelling::turn(){
	// do one turn
	int r;
	int i,j;
	// for each home / family: do you want to move?
	// give it a chance of 10%
	for (i=0; i<XXX; i++) {
		for (j=0; j<YYY; j++) {
			r = rand() % 10 + 1;
			if (r==5 && score(i,j,board[i][j])<2) {
				move(i,j); // move to a nicer spot
			}
		}
	}
}

void schelling::move(int x, int y){
	// move to high score spot
	int s;
	int kind;
	int i,j;
	int bestx, besty, bests;
	kind = board[x][y];
	bestx = 0;
	besty = 0;
	bests = 0;
	const int maxscore = 6;
	// find an empty space close to one's kind
	// (simple brute force approach, not optimized yet)
	for (i=0; i<XXX; i++) {
		for (j=0; j<YYY; j++) {
			if (board[i][j]==0) { // if empty
				s = 0;
				// calculate score
				s = score(i,j,kind);
				// are we doing better now?
				if (s > bests) {
					bestx = i;
					besty = j;
					bests = s;
				}
			}
			if (bests==maxscore) break;
		}
		if (bests==maxscore) break;
	}
	// do the actual move
	board[bestx][besty] = kind;
	board[x][y] = 0;
}

int schelling::score(int x, int y, int kind){
	// calculate score
	// diagonals count half
	int score = 0;
	int diagonal = 0;
	if (x>0)   if (board[x-1][y]==kind) score++;
	if (x<XXX) if (board[x+1][y]==kind) score++;
	if (y>0)   if (board[x][y-1]==kind) score++;
	if (y<YYY) if (board[x][y+1]==kind) score++;
	if (x>0 && y>0)     if (board[x-1][y-1]==kind) diagonal++;
	if (x>0 && y<YYY)   if (board[x][y+1]==kind)   diagonal++;
	if (x<XXX && y>0)   if (board[x+1][y]==kind)   diagonal++;
	if (x<XXX && y<YYY) if (board[x+1][y+1]==kind) diagonal++;
	return score + diagonal/2;
}
